package com.extensibility.util;

import java.util.Enumeration;

public class FilteredEnumerator implements Enumeration {
   Enumeration everything;
   Object onDeck;
   Evaluator eval;

   public FilteredEnumerator(Enumeration var1, Evaluator var2) {
      this.eval = var2;
      this.everything = var1;
      this.onDeck = this.getOnDeck();
   }

   public FilteredEnumerator(Enumeration var1, Class var2) {
      this.eval = new ClassEvaluator((FilteredEnumerator)null, var2);
      this.everything = var1;
      this.onDeck = this.getOnDeck();
   }

   private Object getOnDeck() {
      while(true) {
         if (this.everything.hasMoreElements()) {
            Object var1 = this.everything.nextElement();
            if (!this.eval.isMatch(var1)) {
               continue;
            }

            return var1;
         }

         return null;
      }
   }

   public Object nextElement() {
      Object var1 = this.onDeck;
      this.onDeck = this.getOnDeck();
      return var1;
   }

   public boolean hasMoreElements() {
      return this.onDeck != null;
   }
}
