package com.extensibility.util.coll;

import com.sun.java.util.collections.ArrayList;
import com.sun.java.util.collections.HashMap;

public class IndexedBigList extends BigList {
   private HashMap elementChunkMap;

   public IndexedBigList() {
      this.elementChunkMap = new HashMap();
   }

   public IndexedBigList(int var1) {
      super(var1);
      this.elementChunkMap = new HashMap(var1);
   }

   public IndexedBigList(int var1, int var2) {
      super(var1, var2);
      this.elementChunkMap = new HashMap(var1);
   }

   public int indexOf(Object var1) {
      BigList.ListChunk var2 = (BigList.ListChunk)this.elementChunkMap.get(var1);
      return var2 == null ? -1 : var2.startListIndex + ((ArrayList)var2).indexOf(var1);
   }

   public int lastIndexOf(Object var1) {
      return this.indexOf(var1);
   }

   public boolean contains(Object var1) {
      return this.elementChunkMap.containsKey(var1);
   }

   protected void noteElementLocation(Object var1, BigList.ListChunk var2) {
      if (var2 == null) {
         this.elementChunkMap.remove(var1);
      } else {
         this.elementChunkMap.put(var1, var2);
      }

   }
}
