package com.extensibility.util;

public abstract class SwingWorker {
   private Object value;
   private Thread thread;
   private ThreadVar threadVar;

   public SwingWorker() {
      1 var1 = new 1(this);
      2 var2 = new 2(var1, this);
      Thread var3 = new Thread(var2);
      this.threadVar = new ThreadVar(var3);
      var3.start();
   }

   public abstract Object construct();

   public void finished() {
   }

   public Object get() {
      while(true) {
         Thread var1 = this.threadVar.get();
         if (var1 == null) {
            return this.getValue();
         }

         try {
            var1.join();
         } catch (InterruptedException var4) {
            Thread.currentThread().interrupt();
            Object var3 = null;
            return var3;
         }
      }
   }

   protected synchronized Object getValue() {
      return this.value;
   }

   public void interrupt() {
      Thread var1 = this.threadVar.get();
      if (var1 != null) {
         var1.interrupt();
      }

      this.threadVar.clear();
   }

   private synchronized void setValue(Object var1) {
      this.value = var1;
   }

   // $FF: synthetic method
   static void access$1000071(SwingWorker var0, Object var1) {
      var0.setValue(var1);
   }

   // $FF: synthetic method
   static ThreadVar access$1000171(SwingWorker var0) {
      return var0.threadVar;
   }
}
